#include <amxmodx>
#include <engine>
#include <fun>
#include <hamsandwich>

#define PLUGIN  "CS Revo: Paraquedas Lite"
#define VERSION "1.0"
#define AUTHOR  "Wilian M."

new xCvarSpeed, Float:xOldUserGravity[33]

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)

	xCvarSpeed = register_cvar("parachute_speed", "80")

	RegisterHam(Ham_Spawn, "player", "xPlayerSpawnPost", true)
}

public client_disconnected(id)
{
	xOldUserGravity[id] = 0.0
}

public xPlayerSpawnPost(id)
{
	if(!is_user_alive(id)) return HAM_IGNORED;

	// fixar gravidade real de outros plugins, evita conflito :)
	xOldUserGravity[id] = entity_get_float(id, EV_FL_gravity)

	return HAM_IGNORED
}

public client_PreThink(id)
{
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE

	static Float:xFallspeed, xButton, xOldButton, xFlags 

	xFallspeed = get_pcvar_float(xCvarSpeed) * -1.0
	xButton = get_user_button(id)
	xOldButton = get_user_oldbutton(id)
	xFlags = get_entity_flags(id)

	if((xFlags & FL_ONGROUND))
	{
		if(get_user_gravity(id) == 0.1)
			set_user_gravity(id, xOldUserGravity[id])

		return PLUGIN_CONTINUE
	}

	if((xButton & IN_USE))
	{
		static Float:xVelocity[3]
		entity_get_vector(id, EV_VEC_velocity, xVelocity)

		if(xVelocity[2] < 0.0)
		{
			set_user_gravity(id, 0.1)

			xVelocity[2] = (xVelocity[2] + 40.0 < xFallspeed) ? xVelocity[2] + 40.0 : xFallspeed
			entity_set_vector(id, EV_VEC_velocity, xVelocity)
		}
		else set_user_gravity(id, xOldUserGravity[id])
	}
	else if((xOldButton & IN_USE))
		set_user_gravity(id, xOldUserGravity[id])

	return PLUGIN_CONTINUE
}